<?php
namespace Teknisa\DF\Controllers;

use Teknisa\DF\Services\TipooperacFilialService;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class TipooperacFilialController {
    
    public function __construct(TipooperacFilialService $tipooperacFilialService)
    {
        $this->service = $tipooperacFilialService;
    }
    
    public function put(Request\Row $request, Response $response) {
        
            $rows = $request->getRow();
            $this->service->put($rows);
            
            $return = ["success" => "S"];
            $response->addDataset(new DataSet('Put', $return));
    }
    
    public function insert_filial(Request\Row $request, Response $response) {
        
            $rows = $request->getRow();
            $this->service->insert_filial($rows);
            
            $return = ["success" => "S"];
            $response->addDataset(new DataSet('Insert filial', $return));
    }
    
    public function insert_cliente(Request\Row $request, Response $response) {
        
            $rows = $request->getRow();
            $this->service->insert_cliente($rows);
            
            $return = ["success" => "S"];
            $response->addDataset(new DataSet('Insert cliente', $return));
    }
    
    public function delete_cliente(Request\Row $request, Response $response) {
        
            $rows = $request->getRow();
            $this->service->delete_cliente($rows);
        
    }
    
    public function get_endereco(Request\Row $request, Response $response) {
            
            
            $rows = $request->getRow();
            $endereco = $this->service->get_endereco($rows["CDFILIAL"]);
            
            $return = ["success" => $endereco];
            $response->addDataset(new DataSet('Get', $return));
    }
    
    public function put_endereco(Request\Row $request, Response $response) {
        
            $rows = $request->getRow();
            $this->service->put_endereco($rows);
            
            $return = ["success" => "S"];
            $response->addDataset(new DataSet('Put', $return));
    }
    
}