<?php
namespace Teknisa\DF\Modules\Entrada\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use Teknisa\DF\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\DF\Modules\Entrada\Services\Dfe47000LiberacaoParaFinanceiroService;
use Zeedhi\Framework\DTO\Response;

class Dfe47000LiberacaoParaFinanceiroController extends TeknisaCrud
{
    protected $dfe47000LiberacaoParaFinanceiroService;
    
    public function __construct($crudService, $parameterBag, Dfe47000LiberacaoParaFinanceiroService  $dfe47000LiberacaoParaFinanceiroService) {
        parent::__construct($crudService, $parameterBag);
        $this->dfe47000LiberacaoParaFinanceiroService = $dfe47000LiberacaoParaFinanceiroService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        
        $filterCriteria  = $request->getFilterCriteria();
        $conditionsFront = $filterCriteria->getConditions();
        $defaultCondition = array("columnName" => "", "operator" => "=", "value" => "");
        $conditions = array();
        $this->dataSourceName = 'find_liberacao';
        
        foreach ($conditionsFront as $key => &$condition) {
            
            if($condition["columnName"] == 'DTENTRSAID') {
            
                $defaultCondition["columnName"]  = "ENTRINI";
                $defaultCondition["value"] = $condition["value"][0];
                
                array_push($conditions, $defaultCondition);
                
                $defaultCondition["columnName"]  = "ENTRFIM";
                $defaultCondition["value"] = $condition["value"][1];
            
                array_push($conditions, $defaultCondition);
                
            }else if($condition["columnName"] == 'TCDSERIEENTR') {
                $defaultCondition["columnName"]  = "SERIE";
                $defaultCondition["value"] = $condition["value"];
            
                array_push($conditions, $defaultCondition);
            }else if($condition["columnName"] == 'CDSERIEENTR') {
                $defaultCondition["columnName"]  = "SERIE";
                $defaultCondition["value"] = $condition["value"];
            
                array_push($conditions, $defaultCondition);
            
            }else if($condition["columnName"] == 'DSSERIEENTR') {
                $defaultCondition["columnName"]  = "SERIE";
                $defaultCondition["value"] = $condition["value"];
            
                array_push($conditions, $defaultCondition);
                
            }
            else if($condition["columnName"] == 'TCDTIPOOPER') {
                $defaultCondition["columnName"]  = "TIPOOPER";
                $defaultCondition["value"] = $condition["value"];
            
                array_push($conditions, $defaultCondition);
            }
            else if($condition["columnName"] == 'CDTIPOOPER') {
                $defaultCondition["columnName"]  = "TIPOOPER";
                $defaultCondition["value"] = $condition["value"];
            
                array_push($conditions, $defaultCondition);    
                
            }else if($condition["columnName"] == 'TCDFILIORIG') {
                $defaultCondition["columnName"]  = "FILIAL";
                $defaultCondition["value"] = $condition["value"];
            
                array_push($conditions, $defaultCondition);
            
            }else if($condition["columnName"] == 'CDFILIORIG') {
                $defaultCondition["columnName"]  = "FILIAL";
                $defaultCondition["value"] = $condition["value"];
            
                array_push($conditions, $defaultCondition);    
                
            }else if($condition["columnName"] == 'CDEMPRESA') {
                $defaultCondition["columnName"]  = "EMPRESA";
                $defaultCondition["value"] = $condition["value"];
            
                array_push($conditions, $defaultCondition);
                
            }else if($condition["columnName"] == 'IDBLOQNFFIN') {
                $defaultCondition["columnName"]  = "IDBLOQNFFIN";
                $defaultCondition["value"] = $condition["value"];
            
                array_push($conditions, $defaultCondition);
                
            }else if($condition["columnName"] == 'ERRO') {
    
                if($condition["value"] == "T"){
                    $defaultCondition["columnName"]  = "AVISO";
                    $defaultCondition["value"] = "T";
            
                    array_push($conditions, $defaultCondition);
                    
                    $defaultCondition["columnName"]  = "ERRO";
                    $defaultCondition["value"] = "T";
            
                    array_push($conditions, $defaultCondition);
                    
                }else if($condition["value"] == 2){
                    $defaultCondition["columnName"]  = "AVISO";
                    $defaultCondition["value"] = 0;
            
                    array_push($conditions, $defaultCondition);
                    
                    $defaultCondition["columnName"]  = "ERRO";
                    $defaultCondition["value"] = 0;
            
                    array_push($conditions, $defaultCondition);
                }else{
                    $defaultCondition["columnName"]  = "AVISO";
                    $defaultCondition["value"] = ($condition["value"] == 0) ? 1 : 0;
                    
                    array_push($conditions, $defaultCondition);
                    
                    $defaultCondition["columnName"]  = "ERRO";
                    $defaultCondition["value"] = ($condition["value"] == 1) ? 1 : 0;
                    
                    array_push($conditions, $defaultCondition);
                }
                
            }else {
                array_push($conditions, $condition);
            }
        }
        
        $conditions = $this->setDtEmissao($conditionsFront, $conditions);
        
        $filter = new DataSource\FilterCriteria($this->dataSourceName, $conditions, $filterCriteria->getPage(), $filterCriteria->getPageSize());
        $request = new DTO\Request\Filter($filter, $request->getMethod(), $request->getRoutePath(), $request->getUserId());

        parent::find($request, $response);
    }
    
    private function setDtEmissao($conditionsFront, $conditions){
        $defaultEmisini = array("columnName" => "EMISINI", "operator" => "=", "value" => "30/12/1989");
        $defaultEmisfim = array("columnName" => "EMISFIM", "operator" => "=", "value" => "30/12/1989");
        $defaultEmissao = array("columnName" => "EMISSAO", "operator" => "=", "value" => "T");
        $defaultCondition = array();
        
        foreach ($conditionsFront as $key => &$conditionfront) {

            if($conditionfront["columnName"] == 'DTEMISSAO') {
                
                $defaultEmisini["columnName"]  = "EMISINI";
                $defaultEmisini["value"] = $conditionfront["value"][0];

                $defaultEmisfim["columnName"]  = "EMISFIM";
                $defaultEmisfim["value"] = $conditionfront["value"][1];

                $defaultEmissao["columnName"]  = "EMISSAO";
                $defaultEmissao["value"] = "";
            }
        }
        
        array_push($conditions, $defaultEmisini);
        array_push($conditions, $defaultEmisfim);
        array_push($conditions, $defaultEmissao);
        
        return $conditions;

    }
    
    public function getFilter(DTO\Request\Filter $request, DTO\Response $response) {
        $filter = $this->dfe47000LiberacaoParaFinanceiroService->getFilter();
        $response->addDataset(new DataSet('filter_liberacao', $filter));
    }
    
    public function liberarTitulos(DTO\Request\DataSet $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows();
        
        $notas = array();
        foreach($rows as $nota) {
            if($nota["IDBLOQNFFIN"] == 'B') array_push($notas, $nota);
        }
        if($notas) {
            $retorno = $this->dfe47000LiberacaoParaFinanceiroService->setAprovacao($notas, 'L');
            $response->addMessage(new Response\Message($retorno["SUCESSOS"]));
            $response->addDataset(new DataSet('erros_aprovacao', $retorno["ERROS"]));
        } 
        else {
            $response->addMessage(new Response\Message("Nenhum dos titulos selecionados pode ser liberado."));
            $response->addDataset(new DataSet('erros_aprovacao', array()));
        }
    }
    
    public function liberarTitulosCP(DTO\Request\DataSet $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows();
        
        $notas = array();
        
        
        $idBloqnffin = $this->dfe47000LiberacaoParaFinanceiroService->getIdBloqnffin($rows[1]['CDFILIAL'], $rows[1]['NRLANCTONF']);
        if($idBloqnffin["IDBLOQNFFIN"] == "B"){
            $this->dfe47000LiberacaoParaFinanceiroService->updateNotaFiscal($rows[1], 'L');
        }
        
        
        foreach($rows[0] as $nota) {
            if($nota["IDBLOQNFFINCP"] == 'B' || $nota["IDBLOQNFFINCP"] == null) array_push($notas, $nota);
        }
        
        if($notas) {
            $retorno = $this->dfe47000LiberacaoParaFinanceiroService->setAprovacaoCP($notas, 'L', $rows[1]['NRNOTAFISC'], $rows[1]['DTEMISSAO']);
            $response->addMessage(new Response\Message($retorno["SUCESSOS"]));
            $response->addDataset(new DataSet('erros_aprovacao', $retorno["ERROS"]));
        } 
        else {
            $response->addMessage(new Response\Message("Nenhum dos titulos selecionados pode ser liberado."));
            $response->addDataset(new DataSet('erros_aprovacao', array()));
        }
    }
    
    public function bloquearTitulos(DTO\Request\DataSet $request, DTO\Response $response) {
        $rows  = $request->getDataSet()->getRows();
        $notas = array();
        foreach($rows as $nota) {
            if($nota["IDBLOQNFFIN"] == 'L') array_push($notas, $nota);
        }
        if($notas) {
            $retorno = $this->dfe47000LiberacaoParaFinanceiroService->setAprovacao($notas, 'B');
            $response->addMessage(new Response\Message($retorno["SUCESSOS"]));
            $response->addDataset(new DataSet('erros_aprovacao', $retorno["ERROS"]));
        } 
        else {
            $response->addMessage(new Response\Message("Nenhum dos titulos selecionados pode ser bloqueado."));
            $response->addDataset(new DataSet('erros_aprovacao', array()));
        }
    }
    
    public function bloquearTitulosCP(DTO\Request\DataSet $request, DTO\Response $response) {
        $rows  = $request->getDataSet()->getRows();
        $notas = array();
        foreach($rows[0] as $nota) {
            if($nota["IDBLOQNFFINCP"] == 'L' && $nota["IDSTATPAG"] != 'B') array_push($notas, $nota);
        }
        if($notas) {
            $retorno = $this->dfe47000LiberacaoParaFinanceiroService->setAprovacaoCP($notas, 'B', $rows[1]['NRNOTAFISC'], $rows[1]['DTEMISSAO']);
            $response->addMessage(new Response\Message($retorno["SUCESSOS"]));
            if(!$retorno["ERROS"]){
                $notasCP = $this->dfe47000LiberacaoParaFinanceiroService->getContas($rows[1]['CDFILIAL'], $rows[1]['NRLANCTONF']);
                if($notasCP["QTD"] == 0){
                    $this->dfe47000LiberacaoParaFinanceiroService->updateNotaFiscal($rows[1], 'B');
                }
            }
            
            $response->addDataset(new DataSet('erros_aprovacao', $retorno["ERROS"]));
        
        } 
        else {
            $response->addMessage(new Response\Message("Nenhum dos titulos selecionados pode ser bloqueado."));
            $response->addDataset(new DataSet('erros_aprovacao', array()));
        }
    }
    
    public function updateJustificativa(DTO\Request\DataSet $request, DTO\Response $response){
        $notas  = $request->getDataSet()->getRows();
        
        $this->dfe47000LiberacaoParaFinanceiroService->updateJustificativa($notas);
    }
    
    public function enviaEmailRecusa(DTO\Request\DataSet $request, DTO\Response $response){
        $notas  = $request->getDataSet()->getRows();
        $config = $notas[0]["CONFIG"];
        foreach($notas as $nota){
            $retorno = $this->dfe47000LiberacaoParaFinanceiroService->enviaEmailRecusa($nota, $notas[0]["DSOBSRECUSA"], $config);
        }
    }
}