<?php
namespace Teknisa\DF\Services;

use Teknisa\DF\Factories\TipooperacFilialFactory;

class TipooperacFilialService {

    protected $factory;
    
    public function __construct(TipooperacFilialFactory $factory) {
        $this->factory = $factory;
    }

    public function put($rows) {
        
        foreach($rows as $alteracao){
                $this->factory->put_filial($alteracao["CDFILIAL"], $alteracao["CDTIPOOPER"], $alteracao["NRORG"], $alteracao["IDLIBERADO"], $alteracao["IDLANCMANUAL"]);
        }
    }
    
    public function insert_filial($rows) {
        
        foreach($rows as $alteracao){
                $this->factory->insert_filial($alteracao["CDFILIAL"], $alteracao["CDTIPOOPER"], $alteracao["IDLIBERADO"], $alteracao["IDLANCMANUAL"]);
        }
    }
    
    public function insert_cliente($rows) {
        foreach($rows as $alteracao){
                $this->factory->insert_cliente( $alteracao["CDFILIAL"], $alteracao["CDCLIENTE"], $alteracao["CDTIPOOPER"]);
        }
    }
    
    public function delete_cliente($rows) {
        $this->factory->cliente_delete($rows["CDFILIAL"], $rows["CDTIPOOPER"], $rows["CDCLIENTE"], $rows["IDENTRSAIDOP"],  strval($rows["NRSEQTPOPER"]));
    }
    
    public function get_endereco($cdfilial) {
        
        return $this->factory->endereco_get($cdfilial);
        
    }
    
    public function put_endereco($rows) {
        
        foreach($rows as $alteracao){
                $this->factory->endereco_put($alteracao["CDFILIAL"], $alteracao["CDTIPOOPER"], $alteracao["IDENDEMISTPOPFIL"]);
        }
    }
    
}
